from datetime import datetime
from django import forms

from .models import News


class NewsForm(forms.Form):

    def update(self):
        news = News.objects.get(pk=self.data['news_id'])
        news = self._make(news)
        news.save()

    def create(self):
        news = News()
        news = self._make(news)
        news.company_id = self.data['entity']
        news.save()

    def _make(self, news):
        if self.data['title']:
            news.title = self.data['title']
        if self.data['description']:
            news.description = self.data['description']
        if self.data['url']:
            news.url = self.data['url']

        if self.data['radar']:
            news.radar_id = self.data['radar']
        if self.data['industry']:
            news.industry_id = [int(i) for i in self.data['industry'].split(',')]
        if self.data['function']:
            news.function_id = [int(i) for i in self.data['function'].split(',')]
        if self.data['media']:
            news.media_id = self.data['media']
        if self.data['technology']:
            news.technology_id = [int(i) for i in self.data['technology'].split(',')]
        if self.data['type']:
            news.type_id = self.data['type']
        if self.data['region']:
            news.region_id = self.data['region']
        if self.data['date']:
            news.publish_date = datetime.strptime(self.data['date'], '%Y-%m-%d')

        if self.data['tags']:
            news.tags_id = [int(i) for i in self.data['tags'].split(',')]

        return news
